//---------------------------------------------------------------------------
//
//   Export STL
//
//          Copyright(C) 2011, Claybird
//          Licensed under New BSD License
//
//
//---------------------------------------------------------------------------

#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "MQPlugin.h"
#include "MQ3DLib.h"

#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))

BOOL SaveSTLAscii(const char *filename, MQDocument doc);
BOOL SaveSTLBinary(const char *filename, MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xB3A8500C;
	*ID      = 0xe7e8411e;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "STL Exporter Ver.0.01      Copyright(C) 2011, Claybird";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// o͗pvOCł
	return MQPLUGIN_TYPE_EXPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "STL ascii (*.stl)";
	case 1: return "STL binary (*.stl)";
	// ̃^CvT|[gꍇ͈ȉ̂悤ɂ΂悢ÃTv
	// ł͎ĂȂ߁ARgAEg
	//case 1: return "3D Studio (*.3ds)"; 
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "stl";
	case 1: return "stl";
	//case 1: return "3ds"; 
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQExportFile
//    [ʖŕۑ]ŕۑƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQExportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return SaveSTLAscii(filename, doc);
	case 1: return SaveSTLBinary(filename, doc);
	}
	return FALSE;
}

MQObject GetTargetObject(MQDocument doc)
{
	// IuWFNg̐𓾂
	int objcount = doc->GetObjectCount();

	// ̃IuWFNgPɍ邽߂ɁAƗpIuWFNg쐬
	MQObject obj = MQ_CreateObject();

	// IuWFNgɕ
	for(int i=0; i<objcount; i++){
		MQObject thisobj = doc->GetObject(i);
		if(!thisobj) continue;
		// t[YȂǂɂeύXĂ܂̂ŁAIuWFNg𕡐Ă
		thisobj = thisobj->Clone();
		// ȖʂȂǂ̑t[Y
		thisobj->Freeze(MQOBJECT_FREEZE_ALL);

		// ƗpIuWFNgɍ
		obj->Merge(thisobj);

		// IuWFNg͂svȂ̂Ŕj
		thisobj->DeleteThis();
	}

	return obj;
}

// ASCII`ŏo
BOOL SaveSTLAscii(const char *filename, MQDocument doc)
{
	// t@C쐬EI[v
	FILE *fp = fopen(filename, "w");
	if(!fp)return FALSE;

	// Wϊp_CAO̕\
	MQFileDialogInfo dlginfo;
	memset(&dlginfo, 0, sizeof(dlginfo));
	dlginfo.dwSize = sizeof(dlginfo);
	dlginfo.axis_x = MQFILE_TYPE_RIGHT;
	dlginfo.axis_y = MQFILE_TYPE_UP;
	dlginfo.axis_z = MQFILE_TYPE_BACK;
	dlginfo.softname = "STL format";
	MQ_ShowFileDialog("STL Export", &dlginfo);

	MQObject obj=GetTargetObject(doc);

	//_擾
	int face_count = obj->GetFaceCount();
	int vert_count = obj->GetVertexCount();
	std::vector<MQPoint> vertices(vert_count);
	obj->GetVertexArray(&vertices[0]);
	// W_CAOŎw肵̂ɕϊ
	MQ_ExportAxis(&dlginfo, &vertices[0], vert_count);

	// o
	//---ʎq[begin]
	fprintf(fp,"solid mqexport\n");

	//---ʖɏo
	for(int idx=0; idx<face_count; idx++){
		int indexArray[4];

		// _CfbNX̔z𓾂
		obj->GetFacePointArray(idx, indexArray);

		// }eA͏o͂Ȃ

		// Op`ʂ͂PAlp`ʂ͂Q̖ʂ
		int facePoints=obj->GetFacePointCount(idx);
		for(int base=0;2+base<facePoints;base++){
			MQPoint *p0=&vertices[indexArray[(base*2+0)%facePoints]];
			MQPoint *p1=&vertices[indexArray[(base*2+1)%facePoints]];
			MQPoint *p2=&vertices[indexArray[(base*2+2)%facePoints]];

			MQPoint vNorm=GetNormal(*p0,*p1,*p2);
			vNorm.normalize();
			//---norm
			fprintf(fp," facet normal %e %e %e\n",vNorm.x,vNorm.y,vNorm.z);

			//---vertex
			fprintf(fp,"  outer loop\n");
			fprintf(fp,"   vertex %e %e %e\n",p0->x,p0->y,p0->z);
			fprintf(fp,"   vertex %e %e %e\n",p1->x,p1->y,p1->z);
			fprintf(fp,"   vertex %e %e %e\n",p2->x,p2->y,p2->z);
			fprintf(fp,"  endloop\n");

			fprintf(fp," endfacet\n");
		}
	}

	//---ʎq[end]
	fprintf(fp,"endsolid mqexport\n");

	// t@CN[Y
	fclose(fp);

	// ƗpIuWFNgj
	obj->DeleteThis();

	return TRUE;
}

#pragma pack(push,1)
struct FACE_BIN
{
	float norm[3];
	float v0[3];
	float v1[3];
	float v2[3];
	unsigned __int16 dummy;
};
#pragma pack(pop)

// Binary`ŏo
BOOL SaveSTLBinary(const char *filename, MQDocument doc)
{
	// t@C쐬EI[v
	FILE *fp = fopen(filename, "wb");
	if(!fp)return FALSE;

	// Wϊp_CAO̕\
	MQFileDialogInfo dlginfo;
	memset(&dlginfo, 0, sizeof(dlginfo));
	dlginfo.dwSize = sizeof(dlginfo);
	dlginfo.axis_x = MQFILE_TYPE_RIGHT;
	dlginfo.axis_y = MQFILE_TYPE_UP;
	dlginfo.axis_z = MQFILE_TYPE_BACK;
	dlginfo.softname = "STL format";
	MQ_ShowFileDialog("STL Export", &dlginfo);

	MQObject obj=GetTargetObject(doc);

	//_擾
	int face_count = obj->GetFaceCount();
	int vert_count = obj->GetVertexCount();
	std::vector<MQPoint> vertices(vert_count);
	obj->GetVertexArray(&vertices[0]);
	// W_CAOŎw肵̂ɕϊ
	MQ_ExportAxis(&dlginfo, &vertices[0], vert_count);

	// o
	//---ʎq[begin]
	char header[80]="stl binary file exported by stl exporter by claybird on metasequoia";
	fwrite(header,sizeof(header),1,fp);

	// o͌̎Opʂ̐𐔂
	unsigned __int32 triangle_count = 0;
	for(int face_index=0; face_index<face_count; face_index++){
		switch(obj->GetFacePointCount(face_index)){
		case 3: triangle_count++; break;
		case 4: triangle_count+=2; break;
		}
	}
	fwrite(&triangle_count,sizeof(triangle_count),1,fp);

	//---ʖɏo
	for(int idx=0; idx<face_count; idx++){
		int indexArray[4];
		FACE_BIN data;
		data.dummy=0;

		// _CfbNX̔z𓾂
		obj->GetFacePointArray(idx, indexArray);

		// }eA͏o͂Ȃ

		// Op`ʂ͂PAlp`ʂ͂Q̖ʂ
		int facePoints=obj->GetFacePointCount(idx);
		for(int base=0;2+base<facePoints;base++){
			MQPoint *p0=&vertices[indexArray[(base*2+0)%facePoints]];
			MQPoint *p1=&vertices[indexArray[(base*2+1)%facePoints]];
			MQPoint *p2=&vertices[indexArray[(base*2+2)%facePoints]];

			MQPoint vNorm=GetNormal(*p0,*p1,*p2);
			vNorm.normalize();
			//---norm
			data.norm[0]=vNorm.x;
			data.norm[1]=vNorm.y;
			data.norm[2]=vNorm.z;

			data.v0[0]=p0->x;
			data.v0[1]=p0->y;
			data.v0[2]=p0->z;

			data.v1[0]=p1->x;
			data.v1[1]=p1->y;
			data.v1[2]=p1->z;

			data.v2[0]=p2->x;
			data.v2[1]=p2->y;
			data.v2[2]=p2->z;

			fwrite(&data,sizeof(data),1,fp);
		}
	}

	// t@CN[Y
	fclose(fp);

	// ƗpIuWFNgj
	obj->DeleteThis();

	return TRUE;
}

